<%--
  ADOBE CONFIDENTIAL

  Copyright 2014 Adobe Systems Incorporated
  All Rights Reserved.

  NOTICE:  All information contained herein is, and remains
  the property of Adobe Systems Incorporated and its suppliers,
  if any.  The intellectual and technical concepts contained
  herein are proprietary to Adobe Systems Incorporated and its
  suppliers and may be covered by U.S. and Foreign Patents,
  patents in process, and are protected by trade secret or copyright law.
  Dissemination of this information or reproduction of this material
  is strictly forbidden unless prior written permission is obtained
  from Adobe Systems Incorporated.
--%><%
%><%@include file="/libs/granite/ui/global.jsp" %><%
%><%@page session="false"
          import="java.util.Arrays,
                  java.util.Iterator,
                  java.util.List,
                  org.apache.commons.lang.StringUtils,
                  com.adobe.granite.ui.components.AttrBuilder,
                  com.adobe.granite.ui.components.Config,
                  com.adobe.granite.ui.components.Field,
                  com.adobe.granite.ui.components.Tag,
                  com.adobe.granite.ui.components.Value" %><%--###
Autocomplete
============

.. granite:servercomponent:: /libs/granite/ui/components/coral/foundation/form/autocomplete
   :supertype: /libs/granite/ui/components/coral/foundation/form/field
   
   An autocomplete component that gives a list of suggestions to help the user to complete the field.

   It extends :granite:servercomponent:`Field </libs/granite/ui/components/coral/foundation/form/field>` component.

   It has the following content structure:

   .. gnd:gnd::

      [granite:FormAutocomplete] > granite:FormField
      
      /**
       * The name that identifies the field when submitting the form.
       */
      - name (String)
      
      /**
       * ``true`` to generate the `SlingPostServlet @Delete <http://sling.apache.org/documentation/bundles/manipulating-content-the-slingpostservlet-servlets-post.html#delete>`_ hidden input based on the name.
       */
      - deleteHint (Boolean) = true
      
      /**
       * The value of the field.
       *
       * If ``multiple`` is ``false``, the property type is ``StringEL``, otherwise it is a multiple property of type ``String``.
       */
      - value (String)
      
      /**
       * A hint to the user of what can be entered in the field.
       */
      - emptyText (String) i18n
      
      /**
       * Indicates if the field is in disabled state.
       */
      - disabled (Boolean)
      
      /**
       * Indicates if the field is mandatory to be filled.
       */
      - required (Boolean)
      
      /**
       * The name of the validator to be applied. E.g. ``foundation.jcr.name``.
       * See :doc:`validation </jcr_root/libs/granite/ui/components/coral/foundation/clientlibs/foundation/js/validation/index>` in Granite UI.
       */
      - validation (String) multiple
      
      /**
       * Indicates if the user is able to select multiple selections.
       */
      - multiple (Boolean)

      /**
       * Indicates if the user is forced to select only from the available choices.
       */
      - forceSelection (Boolean)
      
      /**
       * The icon class.
       */
      - icon (String)
      
      /**
       * The renderer to render the user selections (given by the options renderer).
       */
      + values
      
      /**
       * The renderer to render the options to be displayed to the user.
       */
      + options

   Example::
   
      + myfield
        - sling:resourceType = "granite/ui/components/coral/foundation/form/autocomplete"
        - multiple = true
        + datasource
          - sling:resourceType = "cq/gui/components/common/datasources/tags"
        + values
          - sling:resourceType = "granite/ui/components/coral/foundation/form/autocomplete/tags"
        + options
          - sling:resourceType = "granite/ui/components/coral/foundation/form/autocomplete/list"

Components:

.. toctree::
   :glob:

   */index
###--%><%

Config cfg = cmp.getConfig();
String icon = cfg.get("icon", String.class);
boolean multiple = cfg.get("multiple", false);
String name = cfg.get("name", String.class);
boolean disabled = cfg.get("disabled", false);

Resource values = resource.getChild("values");

Tag tag = cmp.consumeTag();
AttrBuilder attrs = tag.getAttrs();
cmp.populateCommonAttrs(attrs);

attrs.addClass("granite-autocomplete coral-Autocomplete smartling-touch-js-language-selector-field");

if (multiple) {
    attrs.add("data-multiple", true);
}

if (cfg.get("forceSelection", false)) {
    attrs.add("data-forceselection", true);
}

if (cfg.get("required", false)) {
    attrs.add("aria-required", true);
}

String validation = StringUtils.join(cfg.get("validation", new String[0]), " ");
attrs.add("data-foundation-validation", validation);
attrs.add("data-validation", validation); // Compatibility


AttrBuilder inputAttrs = new AttrBuilder(request, xssAPI);
inputAttrs.add("type", "text");
inputAttrs.addDisabled(disabled);
inputAttrs.add("placeholder", i18n.getVar(cfg.get("emptyText", String.class)));

if (!multiple) { // if single, the textfield is submitted, otherwise the taglist is submitted
    ValueMap vm = (ValueMap) request.getAttribute(Field.class.getName());

    inputAttrs.add("name", name);
    inputAttrs.add("value", vm.get("value", String.class));
}

inputAttrs.addClass("js-coral-Autocomplete-textfield");
inputAttrs.add("is", "coral-textfield");

AttrBuilder deleteAttrs = new AttrBuilder(request, xssAPI);
deleteAttrs.addClass("foundation-field-related");
deleteAttrs.add("type", "hidden");
deleteAttrs.addDisabled(disabled);
if (name != null && name.trim().length() > 0) {
    deleteAttrs.add("name", name + "@Delete");
}

AttrBuilder buttonAttrs = new AttrBuilder(request, xssAPI);
buttonAttrs.addClass("js-coral-Autocomplete-toggleButton");
buttonAttrs.add("type", "button");
buttonAttrs.add("title", i18n.get("Toggle"));
buttonAttrs.add("is", "coral-button");
buttonAttrs.add("icon", "chevronDown");
buttonAttrs.add("iconSize", "XS");

%><div <%= attrs.build() %>><%
    if (cfg.get("deleteHint", true)) {
        %><input <%= deleteAttrs.build() %>><%
    }
    %><div class="coral-InputGroup coral-InputGroup--block js-coral-Autocomplete-inputGroup"><%
	    if (icon == null) {
	        inputAttrs.addClass("coral-InputGroup-input");
	        
	        %><input <%= inputAttrs.build() %> /><%
	    } else {
	        inputAttrs.addClass("coral-DecoratedTextfield-input");
            
            AttrBuilder iconAttrs = new AttrBuilder(request, xssAPI);
            iconAttrs.addClass("coral-DecoratedTextfield-icon");
            iconAttrs.add("size", "XS");
            iconAttrs.add("icon", icon);
	        
	        %><span class="coral-InputGroup-input coral-DecoratedTextfield">
                <coral-icon <%= iconAttrs %>></coral-icon>
                <input <%= inputAttrs.build() %> />
            </span><%
	    }
        %><span class="coral-InputGroup-button">
            <button class="smartling-touch-js-language-selector-field-deselect-all coral-Button--deselect-all" is="coral-button" variant="secondary" icon="close" iconsize="XS" size="M" class="js-btn-download"
            title="Deselect all"></button>
            <button <%= buttonAttrs %>></button>
	    </span>
    </div><%
    
    if (multiple) {
        AttrBuilder valuesAttrs = new AttrBuilder(request, xssAPI);
        valuesAttrs.addClass("js-coral-Autocomplete-tagList");
        valuesAttrs.add("data-fieldname", name);
        
        cmp.include(values, new Tag(valuesAttrs));
    }
    
    AttrBuilder optionsAttrs = new AttrBuilder(request, xssAPI);
    optionsAttrs.addClass("js-coral-Autocomplete-selectList");
    
    cmp.include(resource.getChild("options"), new Tag(optionsAttrs));
%></div>